Index: s390-tools-sles11/vmur/vmur.h
===================================================================
--- s390-tools-sles11.orig/vmur/vmur.h
+++ s390-tools-sles11/vmur/vmur.h
@@ -96,13 +96,13 @@ const char *ur_action_str[] = {
 	"list",
 };
 
-int ur_action_prefix_len[] = {
-	[RECEIVE] = 2,
-	[PUNCH]   = 3,
-	[PRINT]   = 2,
-	[PURGE]   = 3,
-	[ORDER]   = 2,
-	[LIST]    = 2,
+unsigned int ur_action_prefix_len[] = {
+	2, /* RECEIVE */
+	3, /* PUNCH */
+	2, /* PRINT */
+	3, /* PURGE */
+	2, /* ORDER */
+	2, /* LIST */
 };
 
 struct ccw {
Index: s390-tools-sles11/zconf/Makefile
===================================================================
--- s390-tools-sles11.orig/zconf/Makefile
+++ s390-tools-sles11/zconf/Makefile
@@ -4,15 +4,18 @@
 include ../common.mak
 
 SCRIPTS	= lsdasd lstape lscss chccwdev lsqeth lszfcp lschp chchp lszcrypt \
-	  chzcrypt lsluns
+	  chzcrypt lsluns znetconf
 MANPAGES= lsdasd.8 lstape.8 lscss.8 chccwdev.8 lsqeth.8 lszfcp.8 lschp.8 \
-	  chchp.8 lszcrypt.8 chzcrypt.8 lsluns.8
+	  chchp.8 lszcrypt.8 chzcrypt.8 lsluns.8 znetconf.8
 
 all:
 
 clean:
 
 install:	install-scripts install-manpages
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 lsznet.raw $(TOOLS_LIBDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 znetcontrolunits \
+		$(TOOLS_LIBDIR)
 
 install-scripts:	$(SCRIPTS)
 	@for i in $^; do \
Index: s390-tools-sles11/zconf/lsluns
===================================================================
--- s390-tools-sles11.orig/zconf/lsluns
+++ s390-tools-sles11/zconf/lsluns
@@ -1,10 +1,10 @@
 #!/usr/bin/perl
 
 ###############################################################################
-# Script to list all available LUNs. 
+# Script to list all available LUNs.
 #
 # Copyright IBM Corp. 2008.
-# 
+#
 # Author(s): Martin Petermann <martin@linux.vnet.ibm.com>
 #            Swen Schillig    <swen@vnet.ibm.com>
 #
@@ -22,6 +22,8 @@ my @port = ();
 my $active = "";
 
 my $wlun = "0xc101000000000000";
+my $lun0 = "0x0000000000000000";
+
 
 sub list_luns
 {
@@ -29,19 +31,17 @@ sub list_luns
     my $drv_dir = "/sys/bus/ccw/drivers/zfcp";
     my $sg_dir = "/sys/class/scsi_generic";
     my $man_att;
-    my $lun;
-    my $sg_dev;
 
     foreach my $a (sort keys %res_hash) {
         print "Scanning for LUNs on adapter $a\n";
         foreach my $p (@{$res_hash{$a}}) {
             next if (! -e $drv_dir."/$a/$p");
-            my $stat = `cat $drv_dir/$a/$p/status`;
-            chomp($stat);
-            if (!(hex($stat) & 0x10000000)) {
+            my $status = `cat $drv_dir/$a/$p/access_denied`;
+            $status .= `cat $drv_dir/$a/$p/failed`;
+            $status .= `cat $drv_dir/$a/$p/in_recovery`;
+            if ($status =~ /1/) {
                 print "\tat port $p:\n";
-                print "\t\tPort not online. ",
-                "Cannot scan for LUNs.\n";
+                print "\t\tPort not online. Cannot scan for LUNs.\n";
                 next;
             }
             if (!defined($lun_hash{$a}{$p})) {
@@ -49,33 +49,45 @@ sub list_luns
                 select(undef, undef, undef, 0.1);
                 %lun_hash = get_lun_hash();
                 if (!defined($lun_hash{$a}{$p})) {
-                    `echo $wlun >> $drv_dir/$a/$p/unit_remove`;
-                    print"\tat port $p:\n";
-                    print "\t\tCannot attach WLUN.\n";
-                    next;
+                    `echo $wlun >> $drv_dir/$a/$p/unit_remove 2>/dev/null`;
+                    `echo $lun0 >> $drv_dir/$a/$p/unit_add 2>/dev/null`;
+                    select(undef, undef, undef, 0.1);
+		    %lun_hash = get_lun_hash();
+                    if (!defined($lun_hash{$a}{$p})) {
+                    	`echo $lun0 >> $drv_dir/$a/$p/unit_remove 2>/dev/null`;
+                    	print"\tat port $p:\n";
+                    	print "\t\tCannot attach WLUN / LUN0 for scanning.\n";
+                    	next;
+		    }
                 }
                 $man_att = 1;
             }
-            $lun = ${[keys %{$lun_hash{$a}{$p}}]}[0];
-            $sg_dev = $lun_hash{$a}{$p}{$lun};
-            select(undef, undef, undef, 0.1) while (! -e "/dev/$sg_dev");
-            my @output = `sg_luns /dev/$sg_dev 2>/dev/null`;
-            my $error = $?;
-            if ($man_att) {
-                `echo 1 >> $sg_dir/$sg_dev/device/delete 2>/dev/null`;
-                select(undef, undef, undef, 0.1);
-                `echo $lun >> $drv_dir/$a/$p/unit_remove`;
-                $man_att = 0;
-            }
-            print "\tat port $p:\n";
-            if (!$error && @output) {
-                splice(@output,0,2);
-                map { s/\s*(\w{16})\s*/\t\t0x$1\n/ } @output;
-                print @output;
-            }
-            if ($error) {
-                print "\t\a\tUnable to send the REPORT_LUNS SCSI command to WLUN.\n";
-            }
+
+	    my $retries = 0;
+            foreach my $lun (@{[keys %{$lun_hash{$a}{$p}}]}) {
+            	my $sg_dev = $lun_hash{$a}{$p}{$lun};
+            	select(undef, undef, undef, 0.1) while (! -e "/dev/$sg_dev");
+            	my @output = `sg_luns /dev/$sg_dev 2>/dev/null`;
+            	my $error = $?;
+            	if ($man_att) {
+                	`echo 1 >> $sg_dir/$sg_dev/device/delete 2>/dev/null`;
+                	select(undef, undef, undef, 0.1);
+                	`echo $lun >> $drv_dir/$a/$p/unit_remove 2>/dev/null`;
+                	$man_att = 0;
+            	}
+            	print "\tat port $p:\n" if (!$retries);
+            	if (!$error && @output) {
+                	splice(@output, 0, 2);
+                	map { s/\s*(\w{16})\s*/\t\t0x$1\n/ } @output;
+                	print @output;
+			last;
+            	}
+            	if ($error) {
+                	print "\t\tUnable to send the REPORT_LUNS command to LUN.\n";
+            	}
+		$retries++;
+		last if ($retries > 3);
+	    }
         }
     }
 }
@@ -92,9 +104,9 @@ sub get_lun_hash
         $l =~ s/(0x\w{16})*\n/$1/;
         $p =~ s/(0x\w{16})*\n/$1/;
         chomp($a);
-        
+
         $lun_hash{$a}{$p}{$l} = ${[split('/', $device)]}[-1];
-    }	
+    }
     return %lun_hash;
 }
 
@@ -108,6 +120,11 @@ Usage: $PROGRAM_NAME [<options>]
     The display can be limited by specifying an adapter or a port.
 
 Options:
+    -a, --active
+    Shows all activated LUNs.
+    In addition LUN encryption information is provided.
+    e.g. "lsluns -a"
+
     -c, --ccw
     Shows LUNs for a specific ccw device.
     e.g. "lsluns -c 0.0.3922"
@@ -126,8 +143,8 @@ EOD
 }
 
 sub lsluns_version {
-    print "$PROGRAM_NAME: version %S390_TOOLS_VERSION%.\n";
-    print "Copyright IBM Corp. 2008.\n";
+    print "$PROGRAM_NAME: version %S390_TOOLS_VERSION%\n";
+    print "Copyright IBM Corp. 2008\n";
 }
 
 sub lsluns_invalid_usage {
@@ -159,7 +176,7 @@ reload:
             "Removing from resource list.\n";
         }
     }
-    
+
     push @t_arr, map { @{$res_hash{$_}} } keys %res_hash;
     foreach my $p (@$p_ref_list) {
         if ("@t_arr" !~ /$p/) {
@@ -167,7 +184,7 @@ reload:
             "Removing from resource list.\n";
         }
     }
-    
+
     if (!%res_hash) {
         print "\nNo valid parameters left, ",
         "using all available resources in system.\n\n";
@@ -179,13 +196,46 @@ reload:
     return %res_hash;
 }
 
+sub show_attached_lun_info
+{
+        my %lun_hash = get_lun_hash();
+        my @txt = ("Disk", "Tape", "Printer", "Proc", "WRO",
+                   "CD/DVD", "Scanner", "OMD", "Changer","Comm","n/a",
+                   "n/a","RAID", "Encl");
+
+        foreach my $a (sort keys %lun_hash) {
+                next if ("@adapter" !~ /$a/);
+                print "adapter = $a\n";
+                foreach my $p (sort keys %{$lun_hash{$a}}) {
+                        next if ("@port" !~ /$p/);
+                        print "\tport = $p\n";
+                        foreach my $l (sort keys %{$lun_hash{$a}{$p}}) {
+                                my $sg_dev = "/dev/".$lun_hash{$a}{$p}{$l};
+                                my $inq = `sg_inq -r $sg_dev`;
+                                (my $vend = substr($inq, 0x8, 0x8)) =~ s/\s*//g;
+                                (my $mod = substr($inq, 0x10, 0x10)) =~ s/\s*//g;
+                                my $type = ord(substr($inq, 0x0, 0x1));
+                                my $enc = ($mod =~ /2107/) ?
+                                        ord(substr($inq, 0xa2, 0x1)) : 0;
+                                $l .= "(X)" if ($enc & 0x80);
+                                $txt[$type] = $type if (!defined($txt[$type]));
+                                print("\t\tlun = $l\t$sg_dev\t$txt[$type]",
+                                      "\t$vend:$mod\n");
+                        }
+                }
+        }
+}
+
+
+
 ########### main ################
 
 $PROGRAM_NAME = basename($PROGRAM_NAME);
 
 Getopt::Long::Configure(qw(bundling));
-GetOptions('c|ccw=s' => \@adapter, 
+GetOptions('c|ccw=s' => \@adapter,
 	   'p|port=s'    => \@port,
+	   'a|active'    => \$active,
 	   'v|version'   => sub { lsluns_version(); exit 0; },
 	   'h|help'      => sub { lsluns_usage(); exit 0; },
            ) or do {
@@ -206,5 +256,10 @@ push @port, map { @{$res_hash{$_}} } key
 die "$PROGRAM_NAME: Unable to execute due to missing sg3_utils package. ".
     "Processing stopped.\n" if system("sg_luns -V > /dev/null 2>&1");
 
-list_luns();
+if ($active) {
+        show_attached_lun_info();
+} else {
+        list_luns();
+}
+
 
